
User Interface - Bug #2751

Bug # 2677 (New): fix drawing and functional differences between P2J GUI and 4GL GUI

dragging the scrollbar thumb buttons does not work

10/09/2015 11:47 AM - Greg Shah

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Eugenie Lyzenko % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: GUI Support for a Complex ADM2 App   

billable: No case_num:  

vendor_id: GCD   

Description

History

#1 - 10/09/2015 11:47 AM - Greg Shah

Use demo/demo_widgets.p to recreate.

The primary issues is that dragging the scrollbar thumb buttons doesn't work.

Another thing to check (and fix if needed) in this task: when the use clicks in the non-thumb background of the scrollbar, the scrolling increment

seems different.

#2 - 10/17/2015 09:20 AM - Greg Shah

- Assignee set to Eugenie Lyzenko

#3 - 10/19/2015 03:50 PM - Eugenie Lyzenko

The fix is ready to be committed. The root cause the condition MouseEvent.getButton() != MouseEvent.NOBUTTON is always false during mouse

drag. This is coming from Java when the button value is changing from MouseEvent.NOBUTTON value when the state of the button is changing

during drag(not our case here). The condition that works to enable left mouse button dragging in scrollbar is:

...

(e.getModifiersEx() & MouseEvent.BUTTON1_DOWN_MASK) == MouseEvent.BUTTON1_DOWN_MASK)

...

where e is MouseEvent in mouseDragged() handler.

#4 - 10/19/2015 05:55 PM - Greg Shah

Commit the changes to 1811s and let Hynek review it.
#5 - 10/19/2015 06:49 PM - Eugenie Lyzenko

Task branch 1811s for review updated to revision 10997.

This is the fix for scroll-bar thumb dragging issue.

#6 - 10/20/2015 08:11 AM - Hynek Cihlar

Eugenie Lyzenko wrote:

Task branch 1811s for review updated to revision 10997.

This is the fix for scroll-bar thumb dragging issue.

 

The change is ok.

#7 - 10/20/2015 08:25 AM - Greg Shah

- File combo_box_drop_down_z_order_issue_when_thumb_is_dragged.png added

There is one "regression" caused by this change.  When you drag the thumb button in the combo-box drop-down, the editor widget below the

drop-down draws on top of the drop-down.  So there is some kind of z-order or order of drawing issue here.
#8 - 10/20/2015 08:26 AM - Greg Shah

Another issue: when you make the combo-box drop-down appear, the scrollbars on the editor no longer paint properly.

#9 - 10/20/2015 11:13 AM - Eugenie Lyzenko

The investigation shows this is not related to scrollbar thumb button drag enabled functionality. Because if I disable it - the GUI issues are the same.

The problem started with some recent 1811s update. The recent correct build is 10968 where it works, starting from 10969 the demo_widget.p

produces wrong painting. And now it is not possible to use toggle-box in this demo.

Constantin, can you point what was the changes from 10968 to 10969 in 1811s that can have the effect of incorrect scrollbar and scrollable container

painting? I will debug it anyway so if you do not have fast answer - do not spend a time.

#10 - 10/20/2015 08:57 PM - Eugenie Lyzenko

- File combo_box_drop_down_z_order_issue_when_thumb_is_dragged_fix_20151020.jpg added

Task branch 1811s for review updated to revision 11005.

This is the fix for drop-down painting regression, scrollbar drawing code optimized. The correct screenshot is attached here. The editor scrollbar

painting issue is gone with 11004.

Also the toggle-box regression fixed. Need to prevent NPE in check() method.

#11 - 10/21/2015 09:06 AM - Greg Shah

- Status changed from New to Closed

#12 - 11/10/2015 05:05 AM - Greg Shah

- % Done changed from 0 to 100

#13 - 11/16/2016 12:12 PM - Greg Shah

- Target version changed from Milestone 12 to GUI Support for a Complex ADM2 App
